precision mediump float;
uniform mat4 u_MVMatrix;
uniform mat4 u_MVPMatrix;
uniform vec3 u_LightPos;
uniform vec3 u_LightPos2;

attribute vec4 a_vexPosition;
attribute vec2 a_texCoord;

attribute vec3 a_Normal;

varying vec2 v_texCoord;
varying float v_Diffuse;

void main() {

    if(u_LightPos.z == -9999.0){
        v_Diffuse = 1.0;
    }else{
        vec3 modelViewVertex = vec3(u_MVMatrix * a_vexPosition);
        vec3 modelViewNormal = vec3(u_MVMatrix * vec4(a_Normal, 0.0));
        vec3 lightVector = normalize(u_LightPos - modelViewVertex);
        float diffuse = max(dot(modelViewNormal, lightVector), 0.0);

        v_Diffuse = diffuse ;
        if(v_Diffuse < 1.0){
            v_Diffuse = 1.0 - (1.0 - v_Diffuse) * 0.3;
        }
//        if(v_Diffuse > 100.0){
//            v_Diffuse = 0.0;
//        }
        v_Diffuse = min(v_Diffuse, 1.0);

    }

    gl_Position = u_MVPMatrix * a_vexPosition;
    v_texCoord = a_texCoord;

}